/********************************************************************
  Ɨ^zd[ddRg[[
							for AVR ATTiny(24/44/84) / ATTiny13A

	Author: SUZUKI,Yasufumi Hinodeya Insititute for Ecolife Inc.

  2010/06/30@ƂƃCgAbvVXeƂč\z
  2010/08/08@[dݒ
@2012/04/19@萔
  2012/07/19  Ɩ~߂

LED\
@LED1i΁j@obe[cʕ\
@LED2iԁj@ُ\iߏ[d/[dsj

@d@@@@LED@ LED
@12.0 -      ON @   ߏ[dON
@11.5 - 11.9 BRINK - OFF 
@11.0 - 11.4 BRINK - ON 
@     - 10.9 OFF   - ON 

**********************************************************************/

//ݒl

#define REF 96						//d␳W 100l v␳

									// GND - 12k -+- 47k - VCC-battery(12V)
									//			  |
									//			 ADd

									// 0.1V1JEgƂ悤ɕ␳Đݒ肷
									//      Ȃ킿̓d12V̂ƂA120JEg
									// ADRo[^́A5V/256JEgɊẐ
									//       5  512 = 0.01953V/JEg
									// AD_̓d́A12V̏ꍇ
									//       12.0 ~ 12  ( 12+47 ) = 2.441V
									// Ȃ킿12VƃJEg
									//       2.441  0.01953 = 125JEg
									// d␳ĺi_́j
									//       120 / 125 * 100 = 96
									//
									// @ł͔ŒRŁAߏ[dd𒲐ĂB


//ATTiny13AŎgpꍇɂ͉̃RgO
// ATTiny13Ał̓͊mFĂ܂
//
//#define TINY13

#define WAITMS 200					//C^[oi~bj

#define NOTUSE_LEVEL 110			//gp~鉔~drdi10Vj 11.0V
#define CANUSE_LEVEL 120			//gpJn鉔~drdi10Vj 12.0V
#define CHARGE_ON_LEVEL 135			//[dĊJ鉔~drdi10Vj 13.5V
#define CHARGE_OFF_LEVEL 140		//[d~鉔~drdi10Vj 14.0V

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <util/delay.h>     /* for _delay_ms() */

// }N
#define sbi(PORT,BIT) PORT|=_BV(BIT) 	// PORT̎wBIT1Zbg
#define cbi(PORT,BIT) PORT&=~_BV(BIT) 	// PORT̎wBITNA

// \
enum _ChargeMode {
	FULL,
	CHARGE,
	LOW
};

enum _LEDMode {
	ON,
	OFF
};


// O[oϐ
enum _ChargeMode charge = LOW;
enum _LEDMode led = ON;
uint8_t ad;							//ADRo[^l



// d`FbNƐ
void adc_battery() {
	uint8_t adcs = 0;
	uint16_t calc;
	
	sbi(ADCSRA,ADIF);
	sbi(ADCSRA,ADSC);
	adcs = 0;
	while( bit_is_clear(ADCSRA ,ADIF) ) adcs++;	//ҋ@ԃ`FbNp
	ad = (ADCL>>2);
	ad += (uint8_t)(ADCH<<6);

	calc = (uint16_t)ad * REF;
	calc /= 100;
	ad = (uint8_t)calc;

	// PB0: H = FET ON = [dON
	// PB1: H = FET ON = pON

	//dቺł͋Iɐݒ
	if ( ad < NOTUSE_LEVEL ) {
		charge = LOW;
		sbi( PORTB, 0);		//[dJn
		cbi( PORTB, 1);		//gp~
	}
	
	if ( charge == LOW ) {
		//~
		if ( ad > CANUSE_LEVEL ) {
			charge = CHARGE;
			sbi( PORTB, 0);		//[dJn
			sbi( PORTB, 1);		//gp
		}
	}

	if ( charge == CHARGE ) {
		//[d
		if ( ad > CHARGE_OFF_LEVEL ) {
			charge = FULL;
			cbi( PORTB, 0);		//[d~
		}
	}

	if ( charge == FULL ) { 
		//[d
		if ( ad < CHARGE_ON_LEVEL ) {
			charge = CHARGE;
			sbi( PORTB, 0);		//[dJn
		}
	}
}


// C[`
//
int main()
{

	// ATTiny44 Pin/|[g蓖 
	//
	// 1:*VCC                     14:*GND 
	// 2:*PB0:[dFET         13:*AD0i~drdoj
	// 3:*PB1:pFET         12: PA1:
	// 4: PB3                     11: PA2:
	// 5: PB2                     10: PA3:
	// 6:*PA7:iLED2ԁj           9: PA4:
	// 7:*PA6:iLED1΁j           8: PA5:

	// ATTiny13A Pin/|[g蓖 
	//
	// 1:*ADC0i~drdo)    8:*VCC 
	// 2:*PB4:iLED2ԁj           7:*PB0:[dFET
	// 3:*PB3:iLED1΁j           6:*PB1:pFET
	// 4:*GND                      5: PB2


#ifdef TINY13
	// ATTiny13A
	//|[gԂ̏
	PORTB = 0b00011111; //Port_B ---- HHHH H:o(1) L:o(0)
	DDRB  = 0b00001111; //|[gB o ADC0̂ݓ

#else
	// ATTiny24/44/84
	//|[gԂ̏
	PORTA = 0b11111111; //Port_A HHHH HHHH
	PORTB = 0b00001111; //Port_B ---- HHHH H:o(1) L:o(0)

	DDRA = 0b11111110; //|[gA ADC0̂ݓ́@͏o 
	DDRB = 0b00001111; //|[gB o
#endif

	//ADRo[^[ݒ
	ADMUX = 0b00000000;
		// VCCd(5V)dƂ ADC0gp

	ADCSRA =0b11000100;
		// A/DϊA1ڕϊJn()A16(64kHz)AAϊȂ
		// ADPS 100: 16  64kHz  0.25ms

    for(;;)
    {
		_delay_ms( WAITMS );	//W200msƎs

		adc_battery();

		//_ŃgO
		if ( led == ON ) {
			led = OFF;
		} else {
			led = ON;
		}

#ifdef TINY13
		// ATTiny13A
		if ( ad < NOTUSE_LEVEL ) {
			cbi( PORTB, 3 );
			sbi( PORTB, 4 );
		} else if ( ad < 115 ) {
			if ( led == ON ) {
				cbi( PORTB, 3 );
			} else {
				sbi( PORTB, 3 );
			}
			sbi( PORTB, 4 );
		} else if ( ad < CANUSE_LEVEL ) {
			if ( led == ON ) {
				cbi( PORTB, 3 );
			} else {
				sbi( PORTB, 3 );
			}
			cbi( PORTB, 4 );
		} else if ( charge == CHARGE ) {
			sbi( PORTB, 3 );
			cbi( PORTB, 4 );
		} else {
			sbi( PORTB, 3 );
			sbi( PORTB, 4 );
		}

#else
		// ATTiny24/44/84
		if ( ad < NOTUSE_LEVEL ) {
			cbi( PORTA, 6 );
			sbi( PORTA, 7 );
		} else if ( ad < 115 ) {
			if ( led == ON ) {
				cbi( PORTA, 6 );
			} else {
				sbi( PORTA, 6 );
			}
			sbi( PORTA, 7 );
		} else if ( ad < CANUSE_LEVEL ) {
			if ( led == ON ) {
				cbi( PORTA, 6 );
			} else {
				sbi( PORTA, 6 );
			}
			cbi( PORTA, 7 );
		} else if ( charge == CHARGE ) {
			sbi( PORTA, 6 );
			cbi( PORTA, 7 );
		} else {
			sbi( PORTA, 6 );
			sbi( PORTA, 7 );
		}
#endif

    }

}


